// [AsmJit]
// Machine Code Generation for C++.
//
// [License]
// Zlib - See LICENSE.md file in the package.

#ifndef _ASMJIT_ASMJIT_H
#define _ASMJIT_ASMJIT_H

//! \mainpage API Reference
//!
//! AsmJit C++ API reference documentation generated by Doxygen.
//!
//! Introduction provided by the project page at https://github.com/asmjit/asmjit.
//!
//! \section main_groups Groups
//!
//! The documentation is split into the following groups:
//!
//! $$DOCS_GROUP_OVERVIEW$$
//!
//! \section main_other Other Pages
//!
//!   - <a href="annotated.html">Class List</a> - List of classes sorted alphabetically
//!   - <a href="namespaceasmjit.html">AsmJit Namespace</a> - List of symbols provided by `asmjit` namespace

//! \namespace asmjit
//!
//! Root namespace used by AsmJit.

#include "./core.h"

#ifdef ASMJIT_BUILD_X86
  #include "./x86.h"
#endif

#ifdef ASMJIT_BUILD_ARM
  #include "./arm.h"
#endif

#endif // _ASMJIT_ASMJIT_H
